require ("assets.ProtoPlattform")
require ("assets.ProtoPlayer")
require ("assets.Visualeffects")
require ("assets.Killenemy")
gameover = false
test = 0
shakeron = false

player_contact_enemy = function (self, dt, enemies)
    local contact = false
    for k, v in pairs(enemies) do
        if self.x2 > v.x and self.x < v.x2 and self.y2 > v.y and self.y < v.y2 then
            contact = true
        end
    end
    return contact
end

draw_gameover_screen = function()
    love.graphics.setColor(255,0,0)
    love.graphics.rectangle('fill', 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
    love.graphics.setColor(0,0,0)
    love.graphics.print('game over!', love.graphics.getWidth()/2 -150, love.graphics.getHeight()/2, 0, 4, 4)
end

function love.load()

    player = ProtoPlayer.new(love.graphics.getWidth() / 2, love.graphics.getHeight()-160)
    player.setcolor('green')

    enemy = ProtoPlayer.new(love.graphics.getWidth() / 2, 20)
    enemy.setcolor('red')
    enemy.speed = 80

    enemy2 = ProtoPlayer.new(50, 20)
    enemy2.setcolor('red')
    enemy2.speed = 50

    enemy3 = ProtoPlayer.new(love.graphics.getWidth() -100, 20)
    enemy3.setcolor('red')
    enemy3.speed = 100

    enemies = {enemy, enemy2, enemy3}
    plattforms = {
        ProtoPlattform.new(300, 500, 500, 20, 'plat1'),
        ProtoPlattform.new(0, 370, 200, 20, 'plat2'),
        ProtoPlattform.new(400, 280, 200, 20, 'plat3'),
        ProtoPlattform.new(50, 200, 200, 20, 'plat4'),
        ProtoPlattform.new(500, 100, 200, 20, 'plat5')
    }
end

function love.update(dt)

    if (shakeron) then
        shake(dt)

     end

    player:move(dt)
    player:physic(dt, plattforms)

    for _k, e in pairs(enemies) do
        e:physic(dt, plattforms)
        e:ai(dt, player, plattforms) end

    checkifkill(player, enemies, dt)
    if (player_contact_enemy(player, dt, enemies)) then gameover = true end



end

function love.draw()

    for k, v in pairs(plattforms) do
        v:draw()
    end

    for k, v in pairs(enemies) do
        v:draw()
    end
    player:draw()

    if gameover then draw_gameover_screen() end

end
