ProtoPlattform = {}

ProtoPlattform.new = function(x, y, width, height, name)
    local self = {}
    self.name = name
    self.width = width
    self.height = height
    self.x = x
    self.y = y
    self.x2 = x + width
    self.y2 = y + height
    self.ground = self.y
    self.draw = function()
        love.graphics.setColor(0, 255, 180)
        love.graphics.rectangle('fill', self.x, self.y, self.width, self.height)
        --debug points
        --x/y
        love.graphics.setColor(0, 0, 255)
        love.graphics.rectangle('fill', self.x, self.y, 2, 2)
        --x2/y2
        love.graphics.setColor(255, 0, 0)
        love.graphics.rectangle('fill', self.x2, self.y2, 2, 2)
        --ground
        love.graphics.setColor(0, 255, 255)
        love.graphics.rectangle('fill', self.x + width/2, self.ground - 1, 2, 2)
        -- x/y numbers
        love.graphics.setColor(0, 0, 0)
        love.graphics.print( 'x: ' .. round(self.x,0) .. ' x2: ' .. round(self.x2,0), self.x, self.y)
        -- print plat name
        love.graphics.setColor(0, 0, 0)
        love.graphics.print(self.name, self.x + 100, self.y)


    end

    function round(num, numDecimalPlaces)
        local mult = 10^(numDecimalPlaces or 0)
        return math.floor(num * mult + 0.5) / mult
    end

    return self

end
